/*
   "manip2.mm"
   Simulation of the tow link manipulator
*/
Func void main()
{
	Real t0,t1;
	Real h,dtsav;
	Matrix x0,TC,XC,UC;
	void diff_eqs(),link_eqs();

	t0 = 0.0;  //V~[V̊Jn t=0 ɂ
	t1 = 20.0;  //V~[V̏I t=20 ɂ

//  Ԃ x(0)=[PI*0.75,0.0,0.0,0.0]' ɂ
	x0 = [PI*0.75,0.0,0.0,0.0]';

	h = 1.0e-3; // V~[V̍1msecɂ
	dtsav = 1.0e-2;// f[^10msecɕۑ

	print "Now simulating\n";

// Ode()ɂăV~[Vs
	{TC,XC,UC} = Ode(t0,t1,x0,diff_eqs,link_eqs,h,dtsav);
// diff_eqs() ͔Lq֐
// link_eqs() ͕̔̊֌WLq֐
// TC: Ԃ̎n
// XC: x(t)̎n
// UC: o̓xNg̎n(diff_eqs,link_eqsUY)

//  l\D t, c th1(t),th2(t)
	mgplot(1,Array(TC),Array(XC(1:2,*)));
//  XC(1:2,*)XC1,2sڂ\
//  l\D t, c tau1(t),tau2(t)
//	mgplot(2,Array(TC),Array(UC));
	pause;

//  t@Cɕۑ
	print TC >> "TC.mat";
	print XC >> "XC.mat";
	print UC >> "UC.mat";
}

// diff_eqs() ͔Lq֐
Func void diff_eqs(DX,t,X,UY)
Real t;
Matrix X,DX,UY;
{
	Real th1,th2,th1d,th2d,J1,J2,m1,m2,l1,l2,D1,D2,g;
	Matrix xp,up,dxp;
	Matrix q,qd;
	Matrix d;
	Matrix J,C,D,G;

// X = [[q][qd]];
	q = X(1:2,1);
	qd = X(3:4,1);

//  link_eqs()ŌvZUYD
	up = UY;

// q = [th1,th2]';
	th1 = q(1,1);
	th2 = q(2,1);
// qd = [th1d,th2d]';
	th1d = qd(1,1);
	th2d = qd(2,1);

//  p[^
	m1 = m2 = 1.0;
	l1 = l2 = 1.0;
	J1 = m1*l1^2/3.0+(m1+4*m2)*l1^2;
	J2 = m2*l2^2/3.0+m2*l2^2;
	D1 = 5.0; D2 = 5.0;
	g = 9.805;

//  J(q)̌vZ
	J = [[J1+J2+2*2*m2*l1*l2*cos(th2),J2+2*m2*l1*l2*cos(th2)]
		 [J2+2*m2*l1*l2*cos(th2),J2]];
//  C(q,qd)̌vZ
	C = [[-2*m2*l1*l2*(2*th1d*th2d+th2d^2)*sin(th2)]
		 [2*m2*l1*l2*th1d^2*sin(th2)]];
//  ĎvZ
	D = [[D1,0]
		 [0,D2]];
//  ǦvZ
	G = -[[(m1+2*m2)*l1*g*sin(th1)+m2*l2*g*sin(th1+th2)]
		  [m2*l2*g*sin(th1+th2)]];

//  Od̐ݒ
	d = Z(2,1);

//  
	dxp = [[qd][-J~*(C+D*qd+G)]] + [[Z(2,2)][J~]]*(up+d);

//  ŌɑxDXɓn
	DX = [dxp];
}

// link_eqs() ͕̔̊֌WLq֐
Func void link_eqs(UY,t,X)
Real t;
Matrix UY,X;
{
	Real Kp,Kd;
	Matrix xp,up;
	Matrix q,qd;

// X = [[q][qd]];
	q = X(1:2,1);
	qd = X(3:4,1);

//  ŌUYup̎t̒lnD
	up = Z(2,1);

//  UYupCdiff_eqsɓn
	UY = [up];
}

