/*
   "mckpid.mm"
   Simulation of the following system:
   M x^(2) + C x^(1) + K x = u + d
   q^(1) = x
   u = -Kp x - Kd x^(1) -Ki q , d = 0.5
   Kp = 4.0; Kd = 4.0; Ki = 1.0;
*/

Func void main()
{
	Real t0,t1;
	Real h,dtsav;
	Matrix X0,TC,XC,UC;
	void diff_eqs(),link_eqs();

	t0 = 0.0;  //V~[V̊Jn t=0 ɂ
	t1 = 20.0;  //V~[V̏I t=20 ɂ

//  Ԃ x(0)=[1.0,0.0,0.0]' ɂ
	X0 = [1.0,0.0,0.0]';
//  x0 = [[xp(0)][q(0)]];

	h = 1.0e-3; // V~[V̍1msecɂ
	dtsav = 1.0e-2;// f[^10msecɕۑ

	print "Now simulating\n";

// Ode()ɂăV~[Vs
	{TC,XC,UC} = Ode(t0,t1,X0,diff_eqs,link_eqs,h,dtsav);
// diff_eqs() ͔Lq֐
// link_eqs() ͕̔̊֌WLq֐
// TC: Ԃ̎n
// XC: x(t)̎n
// UC: o̓xNg̎n(diff_eqs,link_eqsUY)

//  l\D t, c x(t)
	mgplot(1,Array(TC),Array(XC(1,*)));
//  XC(1,*)XC1sڂ\
//  l\D t, c u(t)
	mgplot(2,Array(TC),Array(UC));

//  t@Cɕۑ
	print TC >> "TC.mat";
	print XC >> "XC.mat";
	print UC >> "UC.mat";
}

// diff_eqs() ͔Lq֐
Func void diff_eqs(DX,t,X,UY)
Real t;
Matrix X,DX,UY;
{
	Real K,C,M;
	Matrix xp,up,dxp;
	Matrix q,dq;
	Matrix A,B;
	Matrix d;

//  p[^̐ݒ
	K = 1.0; C = 0.4; M = 1.0;

//  A,B̐ݒ
	A = [[0,1][-K/M,-C/M]];
	B = [0,1/M]';

// X=[[xp(t)][q(t)]]\ĂD
	xp = X(1:2,1); 
	q = X(3:3,1);

//  link_eqs()ŌvZUYD
	up = UY;

//  Od̐ݒ
	d = [0.5];

//  
	dxp = A * xp + B * (up + d);
    dq = xp(1:1,1);

//  ŌɑxDXɓn
	DX = [[dxp][dq]];
}

// link_eqs() ͕̔̊֌WLq֐
Func void link_eqs(UY,t,X)
Real t;
Matrix UY,X;
{
	Real Kp,Kd,Ki;
	Matrix xp,up;
	Matrix q;

//  X=[[xp(t)][q(t)]]\ĂD
	xp = X(1:2,1); 
	q = X(3:3,1);
//  Kv͂܂...

//  Kp,Kd,Kiݒ
    Kp = 4.0; Kd = 4.0; Ki = 1.0;

//  ŌUYup̎t̒lnD
	up = [-Kp,-Kd,-Ki] * [[xp][q]];

//  UYupCdiff_eqsɓn
	UY = [up];
}

