/*
   "manip2new.mm"
   Simulation of the tow link manipulator
*/

//  Хѿ
Real J1,J2,m1,m2,l1,l2,D1,D2,g;

Func void main()
{
	Real t0,t1;
	Real h,dtsav;
	Matrix x0,TC,XC,UC;
	void diff_eqs(),link_eqs();

	t0 = 0.0;  //ߥ졼γϻ t=0 ˤ
	t1 = 20.0;  //ߥ졼νλ t=20 ˤ

//  ֤ x(0)=[PI*0.75,0.0,0.0,0.0]' ˤ
	x0 = [PI*0.75,0.0,0.0,0.0]';

	h = 1.0e-3; // ߥ졼ι1msecˤ
	dtsav = 1.0e-2;// ǡ10msec¸

//  ʪѥ᡼
	m1 = m2 = 1.0;
	l1 = l2 = 1.0;
	J1 = m1*l1^2/3.0+(m1+4*m2)*l1^2;
	J2 = m2*l2^2/3.0+m2*l2^2;
	D1 = 5.0; D2 = 5.0;
	g = 9.805;

	print "Now simulating\n";

// Ode()ˤäƥߥ졼Ԥ
	{TC,XC,UC} = Ode(t0,t1,x0,diff_eqs,link_eqs,h,dtsav);
// diff_eqs() ʬ򵭽Ҥؿ
// link_eqs() ʣʬδط򵭽Ҥؿ
// TC: ֤λ
// XC: x(t)λ
// UC: ϥ٥ȥλ(diff_eqs,link_eqsUY)

//  Ͳɽ롥 t, ļ th1(t),th2(t)
//	mgplot(1,Array(TC),Array(XC(1:2,*)));
	mgplot(1,TC,XC(1:2,*));
//  XC(1:2,*)XC1,2ܤɽ
//  Ͳɽ롥 t, ļ tau1(t),tau2(t)
//	mgplot(2,Array(TC),Array(UC));
	pause;

//  ե¸
	print TC >> "TC.mat";
	print XC >> "XC.mat";
	print UC >> "UC.mat";
}

// diff_eqs() ʬ򵭽Ҥؿ
Func void diff_eqs(DX,t,X,UY)
Real t;
Matrix X,DX,UY;
{
	Matrix xp,up,dxp;
	Matrix q,qd;
	Matrix d;
	Matrix J,C,D,G;
	Matrix calJ(),calC(),calD(),calG();

// X = [[q][qd]];
	q = X(1:2,1);
	qd = X(3:4,1);

//  link_eqs()Ƿ׻UY롥
	up = UY;

//  J(q)η׻
	J = calJ(q);

//  C(q,qd)η׻
	C = calC(q,qd);

//  Dη׻
	D = [[D1,0]
		 [0,D2]];

//  Gη׻
	G = calG(q);

//  d
	d = Z(2,1);

//  ʬ
	dxp = [[qd][-J~*(C+D*qd+G)]] + [[Z(2,2)][J~]]*(up+d);

//  Ǹ®٤DXϤ
	DX = [dxp];
}

// link_eqs() ʣʬδط򵭽Ҥؿ
Func void link_eqs(UY,t,X)
Real t;
Matrix UY,X;
{
	Real Kp,Kd;
	Matrix xp,up;
	Matrix q,qd;

// X = [[q][qd]];
	q = X(1:2,1);
	qd = X(3:4,1);

//  ǸUYupλtͤϤ
	up = Z(2,1);

//  UYupdiff_eqsϤ
	UY = [up];
}

//  J(q)η׻Ԥؿ
Func Matrix calJ(q)
	Matrix q;
{
	Real th1,th2;

// q = [th1,th2]';
	th1 = q(1,1);
	th2 = q(2,1);

	return [[J1+J2+2*2*m2*l1*l2*cos(th2),J2+2*m2*l1*l2*cos(th2)]
			[J2+2*m2*l1*l2*cos(th2),J2]];
}

//  C(q,qd)η׻Ԥؿ
Func Matrix calC(q,qd)
	Matrix q,qd;
{
	Real th1,th2,th1d,th2d;

// q = [th1,th2]';
	th1 = q(1,1);
	th2 = q(2,1);
// qd = [th1d,th2d]';
	th1d = qd(1,1);
	th2d = qd(2,1);

	return [[-2*m2*l1*l2*(2*th1d*th2d+th2d^2)*sin(th2)]
			[2*m2*l1*l2*th1d^2*sin(th2)]];
}

//  Gη׻Ԥؿ
Func Matrix calG(q)
	Matrix q;
{
	Real th1,th2;

// q = [th1,th2]';
	th1 = q(1,1);
	th2 = q(2,1);

	return -[[(m1+2*m2)*l1*g*sin(th1)+m2*l2*g*sin(th1+th2)]
		  [m2*l2*g*sin(th1+th2)]];
}
