/*
   "mckpid.mm"
   Simulation of the following system:
   M x^(2) + C x^(1) + K x = u + d
   q^(1) = x
   u = -Kp x - Kd x^(1) -Ki q , d = 0.5
   Kp = 4.0; Kd = 4.0; Ki = 1.0;
*/

Func void main()
{
	Real t0,t1;
	Real h,dtsav;
	Matrix X0,TC,XC,UC;
	void diff_eqs(),link_eqs();

	t0 = 0.0;  //ߥ졼γϻ t=0 ˤ
	t1 = 20.0;  //ߥ졼νλ t=20 ˤ

//  ֤ x(0)=[1.0,0.0,0.0]' ˤ
	X0 = [1.0,0.0,0.0]';
//  x0 = [[xp(0)][q(0)]];

	h = 1.0e-3; // ߥ졼ι1msecˤ
	dtsav = 1.0e-2;// ǡ10msec¸

	print "Now simulating\n";

// Ode()ˤäƥߥ졼Ԥ
	{TC,XC,UC} = Ode(t0,t1,X0,diff_eqs,link_eqs,h,dtsav);
// diff_eqs() ʬ򵭽Ҥؿ
// link_eqs() ʣʬδط򵭽Ҥؿ
// TC: ֤λ
// XC: x(t)λ
// UC: ϥ٥ȥλ(diff_eqs,link_eqsUY)

//  Ͳɽ롥 t, ļ x(t)
	mgplot(1,Array(TC),Array(XC(1,*)));
//  XC(1,*)XC1ܤɽ
//  Ͳɽ롥 t, ļ u(t)
	mgplot(2,Array(TC),Array(UC));

//  ե¸
	print TC >> "TC.mat";
	print XC >> "XC.mat";
	print UC >> "UC.mat";
}

// diff_eqs() ʬ򵭽Ҥؿ
Func void diff_eqs(DX,t,X,UY)
Real t;
Matrix X,DX,UY;
{
	Real K,C,M;
	Matrix xp,up,dxp;
	Matrix q,dq;
	Matrix A,B;
	Matrix d;

//  ʪѥ᡼
	K = 1.0; C = 0.4; M = 1.0;

//  A,B
	A = [[0,1][-K/M,-C/M]];
	B = [0,1/M]';

// X=[[xp(t)][q(t)]]ɽƤ롥
	xp = X(1:2,1); 
	q = X(3:3,1);

//  link_eqs()Ƿ׻UY롥
	up = UY;

//  d
	d = [0.5];

//  ʬ
	dxp = A * xp + B * (up + d);
    dq = xp(1:1,1);

//  Ǹ®٤DXϤ
	DX = [[dxp][dq]];
}

// link_eqs() ʣʬδط򵭽Ҥؿ
Func void link_eqs(UY,t,X)
Real t;
Matrix UY,X;
{
	Real Kp,Kd,Ki;
	Matrix xp,up;
	Matrix q;

//  X=[[xp(t)][q(t)]]ɽƤ롥
	xp = X(1:2,1); 
	q = X(3:3,1);
//  ʬ򤹤ɬפϤޤ...

//  Kp,Kd,Ki
    Kp = 4.0; Kd = 4.0; Ki = 1.0;

//  ǸUYupλtͤϤ
	up = [-Kp,-Kd,-Ki] * [[xp][q]];

//  UYupdiff_eqsϤ
	UY = [up];
}

